typedef struct	Webimage Webimage;

struct Webimage {
	Webimage *next;
	Rune *imsrc;
	Image *i;
};

/*
 * draw.c
*/
extern Image*	eallocimage(Display *, Rectangle, ulong, int, int);
extern void	rect3d(Image *, Rectangle, int, Image **, Point);
extern void	ellipse3d(Image *, Point, int, int, Image **, Point);
extern Font*	getfont(int);
extern void	freefonts(void);
extern Image*	getcolor(int);
extern void	freecolors(void);
extern void	drawstringn(Image *, Point, Image *, Font *, Rune *, int, int);
extern void	drawcheck(Image *, Rectangle, int, int);
extern void	drawbutton(Image *, Rectangle, Rune *, int);
extern void	drawtextarea(Image *, Rectangle, Rune *);

/*
 * html.c
*/
extern void	addanchor(Anchor *);
extern void	sortanchors(void);
extern Anchor*	anchor(int id);
extern char*	urlsuffix(char *);
extern int	charset(uchar *);
extern char*	mimetypefixup(char *q);
extern Rune*	urlcombine(Rune *, Rune *);
extern Rune*	urlencode(Rune *);
extern Rune*	geturl(Rune *, Rune *);

/*
 * load.c
*/
extern void	loadpage(Rune *);

/*
 * render.c
*/
extern Image*	render(Rectangle, Docinfo *, Item *);

/*
 * text.c
*/
extern void	addsnarf(Rectangle, Rune *, int, Font *, Image *, int);
extern void	freesnarf(void);
extern void	drawsnarf(Image *, Point, Point, Point);
extern Rune*	dosnarf(Point, Point);
extern void	drawtext(Image *);
extern void	justifytext(int, int);

/*
 * size.c
 */
extern Point	getsize(Rectangle, Item *);

/*
 * utils.c
*/
extern void*	emalloc(ulong);
extern void*	erealloc(void *, ulong);
extern char*	estrdup(char *);
extern Rune*	erunestrdup(Rune *);
extern int	erfork(int);
extern int	getwebfd(Rune *url, int *);
extern char*	getwebattr(int, char *);
extern int	filter(int, char *, char *, char *);
extern ulong	runehash(Rune *);
extern void	plumbrunestring(Rune *str);
extern void	snarfrunestring(Rune *str);
extern void	newwin(void);
extern void	download(Rune *);

/* widget.c */
extern void	addselect(Rectangle,Item *);
extern void	freeselect(void);
extern void	justifyselect(int, int);
extern Rune*	findhref(Point p);
extern void*	mktextfield(Formfield *, Image *, Rectangle);
extern int	mouseevent(Point);
extern int	kbdevent(Point, Rune);

enum
{
	Border = 2,
	Space = 2,
	Tabspace = 30,

	Checkwidth = 12,
	Checkheight = 12,
	Butmargin = 4,

	Erefresh = 4,
	Nparallel = 8,

	WFont = FntR*NumSize+Tiny,
};

extern Rune location[512];
extern Docinfo *docinfo;
extern Item *docitems;
extern int refresh;
extern Rune *Url;
